LIBRARY IEEE;
USE  IEEE.STD_LOGIC_1164.all;
USE  IEEE.STD_LOGIC_ARITH.all;
USE  IEEE.STD_LOGIC_UNSIGNED.all;

ENTITY clk_div IS

	PORT
	(
		clock_40Mhz				: IN	STD_LOGIC;
		clock_20MHz				: OUT	STD_LOGIC;
		clock_10MHz				: OUT	STD_LOGIC);
	
	
END clk_div;

ARCHITECTURE a OF clk_div IS

	SIGNAL	count_20Mhz: STD_LOGIC_VECTOR(1 DOWNTO 0); 
	SIGNAL	count_10Mhz: STD_LOGIC_VECTOR(2 DOWNTO 0);
        SIGNAL  clock_20Mhz_int, clock_10Mhz_int : STD_LOGIC; 

	
BEGIN
	PROCESS 
	BEGIN
-- Divide by 2
		WAIT UNTIL clock_40Mhz'EVENT and clock_40Mhz = '1';
			IF count_20Mhz < 1 THEN
				count_20Mhz <= count_20Mhz + 1;
			ELSE
				count_20Mhz <= "00";
			END IF;
			IF count_20Mhz < 1 THEN
				clock_20Mhz_int <= '0';
			ELSE
				clock_20Mhz_int <= '1';
			END IF;	

		-- Ripple clocks are used in this code to save prescalar hardware
		-- Sync all clock prescalar outputs back to master clock signal
			clock_20Mhz <= clock_20Mhz_int;
			--clock_10MHZ <= clock_10MHZ_int;
			
	END PROCESS;	

		-- Divide by 2
	PROCESS 
	BEGIN
	   WAIT UNTIL clock_40Mhz'EVENT and clock_40Mhz = '1';
		--WAIT UNTIL clock_20MHZ_int'EVENT and clock_20Mhz_int = '1';
			IF count_10MHZ< 3 THEN
				count_10Mhz <= count_10MHZ + 1;
			ELSE
				count_10Mhz <= "000";
				--clock_10Mhz_int <= NOT clock_10Mhz_int;
			END IF;
			IF count_10Mhz < 2 THEN
				clock_10Mhz_int <= '0';
			ELSE
				clock_10Mhz_int <= '1';
			END IF;	
			--clock_20Mhz <= clock_20Mhz_int;
			clock_10MHZ <= clock_10MHZ_int;
			
	END PROCESS;	

	
END a;

